/* The actual thinkers" */

public class AIAgent extends Thread {
    private Player player;
	private Gamestate state;
	private AIThread ai;

    public AIAgent(AIThread t, Gamestate s, Player p) {
        state = s;
		player = p;
		ai = t;
    }

    public void run() {
    	if (player.type != Player.AI) {
			System.out.println ("Wrong type of player. Quitting AI thread.");
			return;
    	}

    	while (state.gameRunning) {

			// Wait until we are given some time to think
			ai.aisync.waitForTimeSlice ();

			if (state.shutdownOrder) {
				break;
			}
		
			System.out.println ("AI: " + player.name + " is now thinking...");

			// Retrieve data from the gamestate
    		// Lock player list, we don't want new data during thinking
			synchronized (state.getPlayerList ()) {
				try {
					sleep((int)(Math.random() * 3));
				} catch (InterruptedException e) {}
			}

			ai.aisync.returnTimeSlice ();
 			System.out.println ("AI: " + player.name + " stopped ...");

    	}
    }
}

