public class AIAgentSynchronizer {
	private boolean sliceAvailable = true;
	private Object availabilityLock = new Object ();
	private boolean release = false;

	public synchronized void releaseAgents () {
		release = true;
		notifyAll ();
	}

	public synchronized void waitForTimeSlice () {
		if (release) {
			return;
		}
		try {
			wait ();
		} catch (InterruptedException e) {System.out.println ("interrupted");}
	}

	public synchronized void giveTimeSlice () {
		while (true) {
			synchronized (availabilityLock) {
				if (sliceAvailable) 
					break;
			}
		}
		notify ();
		sliceAvailable = false;
	}

	public synchronized void returnTimeSlice () {
		synchronized (availabilityLock) {
			sliceAvailable = true;
		}
	}

	public synchronized boolean timeSliceAvailable () {
		synchronized (availabilityLock) {
			if (sliceAvailable) 
				return true;
		}
		return false;
	}
}