import java.util.*;

/* The "AI thread" */

public class AIThread extends Thread {
    private Gamestate state;
	public AIAgentSynchronizer aisync = new AIAgentSynchronizer ();
	
    public AIThread(Gamestate s) {
        state = s;
    }

    public void run() {
    	
    	while (state.gameRunning) {


    		if (state.getState () == Gamestate.AI) {
    			state.processState ();
    			
    			System.out.println ("AIThread: AI is plotting against the player...");

				// Let's allocate some time for AI (10 ms)
				long timeout = System.currentTimeMillis () + 10;

				// While there is time, allow an AI bot to do some work.
				while (System.currentTimeMillis () < timeout) {	
					aisync.giveTimeSlice ();
					while (!aisync.timeSliceAvailable ());
				}

				

				System.out.println ("AIThread: AI is done.");
   	    		
	    		state.advanceState ();
    		}
    	}

		aisync.releaseAgents ();
    }
}

