import java.util.*;

public class ClientHandler extends Thread {
	private Player player;
    private GameServer server;
	private Gamestate state;
	private Random rnd = new Random ();

	private boolean connected = false;

    public ClientHandler(GameServer s, Gamestate t, Player p) {
        server = s;
		state = t;
		player = p;
		connected = true;
    }

	public Player getPlayer () {
		return player;
	}

    public void run() {
		while (connected) {

			// Do we have the name of the player?
			synchronized (state.getPlayerList ()) {
				if (player.name == null || player.name.length () == 0) {
					player.name = (new Integer (rnd.nextInt (10000))).toString ();
					System.out.println ("Player " + player.name + " joined the game.");
				} 
			}

			try {
   	    		sleep((int)(Math.random() * 100));
   	    	} catch (InterruptedException e) {}

			// With the probability of 10% a player disconnects
			if (rnd.nextInt (10) == 0) {
				server.disconnectClient (this);
				connected = false;
			}
		}
    }
}
