
/* The main class */

public class GameRunner {

	public static void main (String[] args) {
	
		Gamestate state = new Gamestate ();

		GameServer server = new GameServer (state, 10);
		server.start ();
		
		AIThread ai = new AIThread (state);
		PhysicsThread phys = new PhysicsThread (state);
		RenderingThread render = new RenderingThread (state);

		System.out.println ("Starting game!");
		state.runGame ();
		
		Player ai1 = new Player ();
		ai1.type = Player.AI;
		ai1.name = "CPU 1";
		AIAgent agent1 = new AIAgent (ai, state, ai1);
		agent1.start ();

		Player ai2 = new Player ();
		ai2.type = Player.AI;
		ai2.name = "CPU 2";
		AIAgent agent2 = new AIAgent (ai, state, ai2);
		agent2.start ();

		Player ai3 = new Player ();
		ai3.type = Player.AI;
		ai3.name = "CPU 3";
		AIAgent agent3 = new AIAgent (ai, state, ai3);
		agent3.start ();

		ai.start ();
		phys.start ();
		render.start ();
		
		try {
			// Increase this to have more fun.
			Thread.sleep(1000);
		} catch (InterruptedException e) {}

		System.out.println ("Stopping game!");
		state.stopGame ();

	}
}