/* The physics processing thread */

public class PhysicsThread extends Thread {
    private Gamestate state;

    public PhysicsThread(Gamestate s) {
        state = s;
    }

    public void run() {
    	
    	while (state.gameRunning) {
    		if (state.getState () == Gamestate.PHYSICS) {
    			state.processState ();
    			
    			System.out.println ("PhysicsThread: Processing physics data...");
    			// Do fancy physicc processing here.

				// Lock player list, we don't want new data during calculations
				synchronized (state.getPlayerList ()) {

					try {
						sleep((int)(Math.random() * 100));
					} catch (InterruptedException e) {}
					System.out.println ("PhysicsThread: Saving physics results into gamestate...");
   	    		
				}

				state.advanceState ();
    		}
    	}
    }
}

