/* This thread does the "rendering" */

public class RenderingThread extends Thread {
    private Gamestate state;

    public RenderingThread(Gamestate s) {
        state = s;
    }

    public void run() {
    	
    	while (state.gameRunning) {
    		if (state.getState () == Gamestate.RENDERING) {
    			state.processState ();
    			
    			System.out.println ("RenderingThread: Rendering frame...");

				// Do fancy rendering here
   	    		// Lock player list, we don't want new data during rendering
				synchronized (state.getPlayerList ()) {

					try {
						sleep((int)(Math.random() * 100));
					} catch (InterruptedException e) {}
		
				}
				System.out.println ("RenderingThread: Frame rendered...");
   	    		
	    		state.advanceState ();
    		}
    	}
    }
}

