/*
 Blackjack client.
 */

import BlackJackApp.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*;
import java.io.*;

public class BlackJackClient {
	
	static BlackJack gameservice;
	
  public static void main (String args[]) {
		
		try {
			
			ORB orb = ORB.init (args, null);
			
			org.omg.CORBA.Object objRef = orb.resolve_initial_references ("NameService");
			NamingContextExt ncRef = NamingContextExtHelper.narrow (objRef);
			
			String name = "BlackJackServer";
			gameservice = BlackJackHelper.narrow(ncRef.resolve_str(name));
			
			BufferedReader din = new BufferedReader(new InputStreamReader(System.in));
			
			boolean play = true;
			while (play) {
				
				System.out.println ("S - Start a new game.");
				System.out.println ("X - eXit program.");
				System.out.print ("Choice : ");
				
				String choice = din.readLine();
				if (choice.equalsIgnoreCase ("s")) {
					
					gameservice.startGame ();
					
					while (gameservice.getGameState () == BlackJackService.STATE_PLAYING) {
						HandStruct currentHandStruct = gameservice.getHand ();						
						Hand currentHand = new Hand (currentHandStruct);


						System.out.println ("Your current hand: " + currentHand);
						
						System.out.println ("S - Stand.");
						System.out.println ("H - Hit.");
						System.out.print ("Choice : ");
						
						choice = din.readLine();
						if (choice.equalsIgnoreCase ("s")) {
							gameservice.stand ();
						}
						if (choice.equalsIgnoreCase ("h")) {
							gameservice.hit ();
						}
						
						Thread.sleep (500);
					}
					
					System.out.println ("Game over!");
					HandStruct finalHandStruct = gameservice.getHand ();						
					Hand finalHand = new Hand (finalHandStruct);
					System.out.println ("Your final hand: " + finalHand + " (total " + finalHand.getLowValue () + ")");
					
					if (gameservice.getGameState () == BlackJackService.STATE_PLAYERWON) {
						System.out.println ("Player won!");
					} else {
						System.out.println ("Player lost!");
					}
					
					gameservice.resetGame ();
					
					
				} else if (choice.equalsIgnoreCase ("x")) {
					gameservice.shutdownGame ();
					System.out.println ("Exiting...");
					System.exit (0);
					
				} else {
					System.out.println ("Invalid entry!\n");
					continue;
				}
			}
			
		} catch (Exception e) {
			System.out.println("ERROR : " + e) ;
			e.printStackTrace(System.out);
	  }
	}
	
}
