/*
 Blackjack client.
 */

import java.rmi.*;
import java.rmi.Naming;
import java.io.*;
import java.security.*;

public class BlackJackClient {
	
	public static void main(String args[]) throws Exception {

		if (args.length != 1) {
			System.out.println ("Please specify the server hostname as an argument!");
			System.exit(1);
		}
	
		// Our (empty) security manager
		System.setSecurityManager (new RMISecurityManager() {
			public void checkPermission (Permission perm) {}
		});
	
		BufferedReader din = new BufferedReader(new InputStreamReader(System.in));
		
		BlackJackService gameservice = (BlackJackService)Naming.lookup("rmi://" + args[0] + "/BlackjackServer");
			
		boolean play = true;
		while (play) {
			
			System.out.println ("S - Start a new game.");
			System.out.println ("X - eXit program.");
			System.out.print ("Choice : ");
				
			String choice = din.readLine();
			if (choice.equalsIgnoreCase ("s")) {
				
				gameservice.startGame ();
				
				while (gameservice.getGameState () == BlackJackService.STATE_PLAYING) {
					Hand currentHand = gameservice.getHand ();
					System.out.println ("Your current hand: " + currentHand);

					System.out.println ("S - Stand.");
					System.out.println ("H - Hit.");
					System.out.print ("Choice : ");

					choice = din.readLine();
					if (choice.equalsIgnoreCase ("s")) {
						gameservice.stand ();
					}
					if (choice.equalsIgnoreCase ("h")) {
						gameservice.hit ();
					}
					
					Thread.sleep (500);
				}
				
				System.out.println ("Game over!");
				Hand finalHand = gameservice.getHand ();
				System.out.println ("Your final hand: " + finalHand + " (total " + finalHand.getLowValue () + ")");
				
				if (gameservice.getGameState () == BlackJackService.STATE_PLAYERWON) {
					System.out.println ("Player won!");
				} else {
					System.out.println ("Player lost!");
				}
				
				gameservice.resetGame ();
				
				
			} else if (choice.equalsIgnoreCase ("x")) {
				System.out.println ("Exiting...");
				System.exit (0);

			} else {
				System.out.println ("Invalid entry!\n");
				continue;
			}
		}
		}
}
