/*
 A game of blackjack.
 */

import java.rmi.*;

public interface BlackJackService extends java.rmi.Remote
{
	public static final int STATE_WAITING = 0;
	public static final int STATE_PLAYING = 1;
	public static final int STATE_PLAYERWON = 2;
	public static final int STATE_PLAYERBUSTED = 3;
	
	// Start new game
	public void startGame () throws RemoteException;
	
	// Get gamestate
	public int getGameState () throws RemoteException;
	
	// Get the current hand
	public Hand getHand () throws RemoteException;
	
	// Hit
	public void hit () throws RemoteException;

	// Stand
	public void stand () throws RemoteException;
	
	// Reset the game
	public void resetGame () throws RemoteException;
	
}