/*
 A card in a deck
 */

import java.io.*;

public class Card implements Serializable {

	public int suit;
	public int rank;

	public Card (int newsuit, int newrank) {
		suit = newsuit;
		rank = newrank;
	}
	
	public String toString () {
		String desc = "";
		
		if (rank > 1 && rank < 11) 
			desc = desc + rank;
		else if (rank == 11) 
			desc = desc + "Jack";
		else if (rank == 12) 
			desc = desc + "Queen";
		else if (rank == 13) 
			desc = desc + "King";
		else if (rank == 14) 
			desc = desc + "Ace";
		else
			desc = desc + "Unknown";
		
		
		desc = desc + " of";
		
		if (suit == 1) 
			desc = desc + " hearts";
		else if (suit == 2) 
			desc = desc + " spades";
		else if (suit == 3) 
			desc = desc + " clubs";
		else if (suit == 4) 
			desc = desc + " diamonds";
		else
			desc = desc + " unknown";
		
		return desc;		
	}
	
	private void writeObject(ObjectOutputStream s) throws IOException {
	    s.defaultWriteObject();
	    s.writeInt(suit);
			s.writeInt(rank);
	}
  
	private void readObject(ObjectInputStream s) throws IOException, ClassNotFoundException  {
	    s.defaultReadObject();
	    suit = s.readInt();
	    rank = s.readInt();			
	}
}
