/*
 A hand of cards.
 */

import java.util.Vector;
import java.io.*;

public class Hand implements Serializable {
	Vector<Card> cards = new Vector<Card> ();
	
	public void addCard (Card c) {
		cards.add (c);
	}

	public int getLowValue () {
		int val = 0;
		
		for (int i = 0; i < cards.size (); i++) {
			Card c = cards.get(i);
			if (c.rank == 14)
				val += 1;
			else if (c.rank > 10 && c.rank <  14)
				val += 10;
			else
				val += c.rank;
		}
		return val;
	}

	public int getHighValue () {
		int val = 0;
		
		for (int i = 0; i < cards.size (); i++) {
			Card c = cards.get(i);
			if (c.rank > 10 && c.rank <  14)
				val += 10;
			else
				val += c.rank;
		}
		return val;
	}
	
	public String toString () {
		String val = "";
		
		
		if (cards.size () > 0) {
			Card c = cards.get(0);
			val = c.toString ();
			if (cards.size () > 1) {
				for (int i = 1; i < cards.size (); i++) {
					c = cards.get(i);
					val += ", " + c.toString ();
				}
			}
			
		}
		return val;		
	}

	private void writeObject(ObjectOutputStream s) throws IOException {
		s.defaultWriteObject();
		s.writeObject(cards);
	}
  
	private void readObject(ObjectInputStream s) throws IOException, ClassNotFoundException  {
		s.defaultReadObject();
		cards = (Vector<Card>)s.readObject ();
	}
	
}
